// **********************************************************************
//
// Copyright (c) 2003-2008 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.0
// Generated from file `PropertyType.ice'

#include <PropertyType.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 0
#       error Ice patch level mismatch!
#   endif
#endif

::Ice::Object* IceInternal::upCast(::P::T* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::P::T* p) { return p; }

::Ice::Object* IceInternal::upCast(::P::BoolT* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::P::BoolT* p) { return p; }

::Ice::Object* IceInternal::upCast(::P::ByteT* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::P::ByteT* p) { return p; }

::Ice::Object* IceInternal::upCast(::P::ByteSeqT* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::P::ByteSeqT* p) { return p; }

::Ice::Object* IceInternal::upCast(::P::IntT* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::P::IntT* p) { return p; }

::Ice::Object* IceInternal::upCast(::P::FloatT* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::P::FloatT* p) { return p; }

::Ice::Object* IceInternal::upCast(::P::StringT* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::P::StringT* p) { return p; }

::Ice::Object* IceInternal::upCast(::P::StringSeqT* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::P::StringSeqT* p) { return p; }

::Ice::Object* IceInternal::upCast(::P::ObjectT* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::P::ObjectT* p) { return p; }

void
P::__read(::IceInternal::BasicStream* __is, ::P::TPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::P::T;
        v->__copyFrom(proxy);
    }
}

void
P::__read(::IceInternal::BasicStream* __is, ::P::BoolTPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::P::BoolT;
        v->__copyFrom(proxy);
    }
}

void
P::__read(::IceInternal::BasicStream* __is, ::P::ByteTPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::P::ByteT;
        v->__copyFrom(proxy);
    }
}

void
P::__read(::IceInternal::BasicStream* __is, ::P::ByteSeqTPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::P::ByteSeqT;
        v->__copyFrom(proxy);
    }
}

void
P::__read(::IceInternal::BasicStream* __is, ::P::IntTPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::P::IntT;
        v->__copyFrom(proxy);
    }
}

void
P::__read(::IceInternal::BasicStream* __is, ::P::FloatTPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::P::FloatT;
        v->__copyFrom(proxy);
    }
}

void
P::__read(::IceInternal::BasicStream* __is, ::P::StringTPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::P::StringT;
        v->__copyFrom(proxy);
    }
}

void
P::__read(::IceInternal::BasicStream* __is, ::P::StringSeqTPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::P::StringSeqT;
        v->__copyFrom(proxy);
    }
}

void
P::__read(::IceInternal::BasicStream* __is, ::P::ObjectTPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::P::ObjectT;
        v->__copyFrom(proxy);
    }
}

const ::std::string&
IceProxy::P::T::ice_staticId()
{
    return ::P::T::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::P::T::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::P::T);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::P::T::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::P::T);
}

::IceProxy::Ice::Object*
IceProxy::P::T::__newInstance() const
{
    return new T;
}

const ::std::string&
IceProxy::P::BoolT::ice_staticId()
{
    return ::P::BoolT::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::P::BoolT::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::P::BoolT);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::P::BoolT::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::P::BoolT);
}

::IceProxy::Ice::Object*
IceProxy::P::BoolT::__newInstance() const
{
    return new BoolT;
}

const ::std::string&
IceProxy::P::ByteT::ice_staticId()
{
    return ::P::ByteT::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::P::ByteT::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::P::ByteT);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::P::ByteT::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::P::ByteT);
}

::IceProxy::Ice::Object*
IceProxy::P::ByteT::__newInstance() const
{
    return new ByteT;
}

const ::std::string&
IceProxy::P::ByteSeqT::ice_staticId()
{
    return ::P::ByteSeqT::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::P::ByteSeqT::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::P::ByteSeqT);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::P::ByteSeqT::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::P::ByteSeqT);
}

::IceProxy::Ice::Object*
IceProxy::P::ByteSeqT::__newInstance() const
{
    return new ByteSeqT;
}

const ::std::string&
IceProxy::P::IntT::ice_staticId()
{
    return ::P::IntT::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::P::IntT::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::P::IntT);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::P::IntT::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::P::IntT);
}

::IceProxy::Ice::Object*
IceProxy::P::IntT::__newInstance() const
{
    return new IntT;
}

const ::std::string&
IceProxy::P::FloatT::ice_staticId()
{
    return ::P::FloatT::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::P::FloatT::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::P::FloatT);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::P::FloatT::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::P::FloatT);
}

::IceProxy::Ice::Object*
IceProxy::P::FloatT::__newInstance() const
{
    return new FloatT;
}

const ::std::string&
IceProxy::P::StringT::ice_staticId()
{
    return ::P::StringT::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::P::StringT::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::P::StringT);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::P::StringT::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::P::StringT);
}

::IceProxy::Ice::Object*
IceProxy::P::StringT::__newInstance() const
{
    return new StringT;
}

const ::std::string&
IceProxy::P::StringSeqT::ice_staticId()
{
    return ::P::StringSeqT::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::P::StringSeqT::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::P::StringSeqT);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::P::StringSeqT::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::P::StringSeqT);
}

::IceProxy::Ice::Object*
IceProxy::P::StringSeqT::__newInstance() const
{
    return new StringSeqT;
}

const ::std::string&
IceProxy::P::ObjectT::ice_staticId()
{
    return ::P::ObjectT::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::P::ObjectT::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::P::ObjectT);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::P::ObjectT::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::P::ObjectT);
}

::IceProxy::Ice::Object*
IceProxy::P::ObjectT::__newInstance() const
{
    return new ObjectT;
}

::Ice::ObjectPtr
P::T::ice_clone() const
{
    ::P::TPtr __p = new ::P::T(*this);
    return __p;
}

static const ::std::string __P__T_ids[2] =
{
    "::Ice::Object",
    "::P::T"
};

bool
P::T::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__P__T_ids, __P__T_ids + 2, _s);
}

::std::vector< ::std::string>
P::T::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__P__T_ids[0], &__P__T_ids[2]);
}

const ::std::string&
P::T::ice_id(const ::Ice::Current&) const
{
    return __P__T_ids[1];
}

const ::std::string&
P::T::ice_staticId()
{
    return __P__T_ids[1];
}

void
P::T::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
P::T::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
P::T::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type P::T was not generated with stream support";
    throw ex;
}

void
P::T::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type P::T was not generated with stream support";
    throw ex;
}

class __F__P__T : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::P::T::ice_staticId());
        return new ::P::T;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__P__T_Ptr = new __F__P__T;

const ::Ice::ObjectFactoryPtr&
P::T::ice_factory()
{
    return __F__P__T_Ptr;
}

class __F__P__T__Init
{
public:

    __F__P__T__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::P::T::ice_staticId(), ::P::T::ice_factory());
    }

    ~__F__P__T__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::P::T::ice_staticId());
    }
};

static __F__P__T__Init __F__P__T__i;

#ifdef __APPLE__
extern "C" { void __F__P__T__initializer() {} }
#endif

void 
P::__patch__TPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::P::TPtr* p = static_cast< ::P::TPtr*>(__addr);
    assert(p);
    *p = ::P::TPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::P::T::ice_staticId(), v->ice_id());
    }
}

bool
P::operator==(const ::P::T& l, const ::P::T& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
P::operator<(const ::P::T& l, const ::P::T& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

P::BoolT::BoolT(bool __ice_value) :
    value(__ice_value)
{
}

::Ice::ObjectPtr
P::BoolT::ice_clone() const
{
    ::P::BoolTPtr __p = new ::P::BoolT(*this);
    return __p;
}

static const ::std::string __P__BoolT_ids[3] =
{
    "::Ice::Object",
    "::P::BoolT",
    "::P::T"
};

bool
P::BoolT::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__P__BoolT_ids, __P__BoolT_ids + 3, _s);
}

::std::vector< ::std::string>
P::BoolT::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__P__BoolT_ids[0], &__P__BoolT_ids[3]);
}

const ::std::string&
P::BoolT::ice_id(const ::Ice::Current&) const
{
    return __P__BoolT_ids[1];
}

const ::std::string&
P::BoolT::ice_staticId()
{
    return __P__BoolT_ids[1];
}

void
P::BoolT::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(value);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    T::__write(__os);
#else
    ::P::T::__write(__os);
#endif
}

void
P::BoolT::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(value);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    T::__read(__is, true);
#else
    ::P::T::__read(__is, true);
#endif
}

void
P::BoolT::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type P::BoolT was not generated with stream support";
    throw ex;
}

void
P::BoolT::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type P::BoolT was not generated with stream support";
    throw ex;
}

class __F__P__BoolT : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::P::BoolT::ice_staticId());
        return new ::P::BoolT;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__P__BoolT_Ptr = new __F__P__BoolT;

const ::Ice::ObjectFactoryPtr&
P::BoolT::ice_factory()
{
    return __F__P__BoolT_Ptr;
}

class __F__P__BoolT__Init
{
public:

    __F__P__BoolT__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::P::BoolT::ice_staticId(), ::P::BoolT::ice_factory());
    }

    ~__F__P__BoolT__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::P::BoolT::ice_staticId());
    }
};

static __F__P__BoolT__Init __F__P__BoolT__i;

#ifdef __APPLE__
extern "C" { void __F__P__BoolT__initializer() {} }
#endif

void 
P::__patch__BoolTPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::P::BoolTPtr* p = static_cast< ::P::BoolTPtr*>(__addr);
    assert(p);
    *p = ::P::BoolTPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::P::BoolT::ice_staticId(), v->ice_id());
    }
}

bool
P::operator==(const ::P::BoolT& l, const ::P::BoolT& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
P::operator<(const ::P::BoolT& l, const ::P::BoolT& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

P::ByteT::ByteT(::Ice::Byte __ice_value) :
    value(__ice_value)
{
}

::Ice::ObjectPtr
P::ByteT::ice_clone() const
{
    ::P::ByteTPtr __p = new ::P::ByteT(*this);
    return __p;
}

static const ::std::string __P__ByteT_ids[3] =
{
    "::Ice::Object",
    "::P::ByteT",
    "::P::T"
};

bool
P::ByteT::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__P__ByteT_ids, __P__ByteT_ids + 3, _s);
}

::std::vector< ::std::string>
P::ByteT::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__P__ByteT_ids[0], &__P__ByteT_ids[3]);
}

const ::std::string&
P::ByteT::ice_id(const ::Ice::Current&) const
{
    return __P__ByteT_ids[1];
}

const ::std::string&
P::ByteT::ice_staticId()
{
    return __P__ByteT_ids[1];
}

void
P::ByteT::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(value);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    T::__write(__os);
#else
    ::P::T::__write(__os);
#endif
}

void
P::ByteT::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(value);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    T::__read(__is, true);
#else
    ::P::T::__read(__is, true);
#endif
}

void
P::ByteT::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type P::ByteT was not generated with stream support";
    throw ex;
}

void
P::ByteT::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type P::ByteT was not generated with stream support";
    throw ex;
}

class __F__P__ByteT : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::P::ByteT::ice_staticId());
        return new ::P::ByteT;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__P__ByteT_Ptr = new __F__P__ByteT;

const ::Ice::ObjectFactoryPtr&
P::ByteT::ice_factory()
{
    return __F__P__ByteT_Ptr;
}

class __F__P__ByteT__Init
{
public:

    __F__P__ByteT__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::P::ByteT::ice_staticId(), ::P::ByteT::ice_factory());
    }

    ~__F__P__ByteT__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::P::ByteT::ice_staticId());
    }
};

static __F__P__ByteT__Init __F__P__ByteT__i;

#ifdef __APPLE__
extern "C" { void __F__P__ByteT__initializer() {} }
#endif

void 
P::__patch__ByteTPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::P::ByteTPtr* p = static_cast< ::P::ByteTPtr*>(__addr);
    assert(p);
    *p = ::P::ByteTPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::P::ByteT::ice_staticId(), v->ice_id());
    }
}

bool
P::operator==(const ::P::ByteT& l, const ::P::ByteT& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
P::operator<(const ::P::ByteT& l, const ::P::ByteT& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

P::ByteSeqT::ByteSeqT(const ::Ice::ByteSeq& __ice_value) :
    value(__ice_value)
{
}

::Ice::ObjectPtr
P::ByteSeqT::ice_clone() const
{
    ::P::ByteSeqTPtr __p = new ::P::ByteSeqT(*this);
    return __p;
}

static const ::std::string __P__ByteSeqT_ids[3] =
{
    "::Ice::Object",
    "::P::ByteSeqT",
    "::P::T"
};

bool
P::ByteSeqT::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__P__ByteSeqT_ids, __P__ByteSeqT_ids + 3, _s);
}

::std::vector< ::std::string>
P::ByteSeqT::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__P__ByteSeqT_ids[0], &__P__ByteSeqT_ids[3]);
}

const ::std::string&
P::ByteSeqT::ice_id(const ::Ice::Current&) const
{
    return __P__ByteSeqT_ids[1];
}

const ::std::string&
P::ByteSeqT::ice_staticId()
{
    return __P__ByteSeqT_ids[1];
}

void
P::ByteSeqT::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    if(value.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        __os->write(&value[0], &value[0] + value.size());
    }
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    T::__write(__os);
#else
    ::P::T::__write(__os);
#endif
}

void
P::ByteSeqT::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    ::std::pair<const ::Ice::Byte*, const ::Ice::Byte*> ___value;
    __is->read(___value);
    ::std::vector< ::Ice::Byte>(___value.first, ___value.second).swap(value);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    T::__read(__is, true);
#else
    ::P::T::__read(__is, true);
#endif
}

void
P::ByteSeqT::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type P::ByteSeqT was not generated with stream support";
    throw ex;
}

void
P::ByteSeqT::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type P::ByteSeqT was not generated with stream support";
    throw ex;
}

class __F__P__ByteSeqT : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::P::ByteSeqT::ice_staticId());
        return new ::P::ByteSeqT;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__P__ByteSeqT_Ptr = new __F__P__ByteSeqT;

const ::Ice::ObjectFactoryPtr&
P::ByteSeqT::ice_factory()
{
    return __F__P__ByteSeqT_Ptr;
}

class __F__P__ByteSeqT__Init
{
public:

    __F__P__ByteSeqT__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::P::ByteSeqT::ice_staticId(), ::P::ByteSeqT::ice_factory());
    }

    ~__F__P__ByteSeqT__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::P::ByteSeqT::ice_staticId());
    }
};

static __F__P__ByteSeqT__Init __F__P__ByteSeqT__i;

#ifdef __APPLE__
extern "C" { void __F__P__ByteSeqT__initializer() {} }
#endif

void 
P::__patch__ByteSeqTPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::P::ByteSeqTPtr* p = static_cast< ::P::ByteSeqTPtr*>(__addr);
    assert(p);
    *p = ::P::ByteSeqTPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::P::ByteSeqT::ice_staticId(), v->ice_id());
    }
}

bool
P::operator==(const ::P::ByteSeqT& l, const ::P::ByteSeqT& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
P::operator<(const ::P::ByteSeqT& l, const ::P::ByteSeqT& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

P::IntT::IntT(::Ice::Int __ice_value) :
    value(__ice_value)
{
}

::Ice::ObjectPtr
P::IntT::ice_clone() const
{
    ::P::IntTPtr __p = new ::P::IntT(*this);
    return __p;
}

static const ::std::string __P__IntT_ids[3] =
{
    "::Ice::Object",
    "::P::IntT",
    "::P::T"
};

bool
P::IntT::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__P__IntT_ids, __P__IntT_ids + 3, _s);
}

::std::vector< ::std::string>
P::IntT::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__P__IntT_ids[0], &__P__IntT_ids[3]);
}

const ::std::string&
P::IntT::ice_id(const ::Ice::Current&) const
{
    return __P__IntT_ids[1];
}

const ::std::string&
P::IntT::ice_staticId()
{
    return __P__IntT_ids[1];
}

void
P::IntT::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(value);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    T::__write(__os);
#else
    ::P::T::__write(__os);
#endif
}

void
P::IntT::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(value);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    T::__read(__is, true);
#else
    ::P::T::__read(__is, true);
#endif
}

void
P::IntT::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type P::IntT was not generated with stream support";
    throw ex;
}

void
P::IntT::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type P::IntT was not generated with stream support";
    throw ex;
}

class __F__P__IntT : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::P::IntT::ice_staticId());
        return new ::P::IntT;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__P__IntT_Ptr = new __F__P__IntT;

const ::Ice::ObjectFactoryPtr&
P::IntT::ice_factory()
{
    return __F__P__IntT_Ptr;
}

class __F__P__IntT__Init
{
public:

    __F__P__IntT__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::P::IntT::ice_staticId(), ::P::IntT::ice_factory());
    }

    ~__F__P__IntT__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::P::IntT::ice_staticId());
    }
};

static __F__P__IntT__Init __F__P__IntT__i;

#ifdef __APPLE__
extern "C" { void __F__P__IntT__initializer() {} }
#endif

void 
P::__patch__IntTPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::P::IntTPtr* p = static_cast< ::P::IntTPtr*>(__addr);
    assert(p);
    *p = ::P::IntTPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::P::IntT::ice_staticId(), v->ice_id());
    }
}

bool
P::operator==(const ::P::IntT& l, const ::P::IntT& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
P::operator<(const ::P::IntT& l, const ::P::IntT& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

P::FloatT::FloatT(::Ice::Float __ice_value) :
    value(__ice_value)
{
}

::Ice::ObjectPtr
P::FloatT::ice_clone() const
{
    ::P::FloatTPtr __p = new ::P::FloatT(*this);
    return __p;
}

static const ::std::string __P__FloatT_ids[3] =
{
    "::Ice::Object",
    "::P::FloatT",
    "::P::T"
};

bool
P::FloatT::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__P__FloatT_ids, __P__FloatT_ids + 3, _s);
}

::std::vector< ::std::string>
P::FloatT::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__P__FloatT_ids[0], &__P__FloatT_ids[3]);
}

const ::std::string&
P::FloatT::ice_id(const ::Ice::Current&) const
{
    return __P__FloatT_ids[1];
}

const ::std::string&
P::FloatT::ice_staticId()
{
    return __P__FloatT_ids[1];
}

void
P::FloatT::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(value);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    T::__write(__os);
#else
    ::P::T::__write(__os);
#endif
}

void
P::FloatT::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(value);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    T::__read(__is, true);
#else
    ::P::T::__read(__is, true);
#endif
}

void
P::FloatT::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type P::FloatT was not generated with stream support";
    throw ex;
}

void
P::FloatT::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type P::FloatT was not generated with stream support";
    throw ex;
}

class __F__P__FloatT : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::P::FloatT::ice_staticId());
        return new ::P::FloatT;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__P__FloatT_Ptr = new __F__P__FloatT;

const ::Ice::ObjectFactoryPtr&
P::FloatT::ice_factory()
{
    return __F__P__FloatT_Ptr;
}

class __F__P__FloatT__Init
{
public:

    __F__P__FloatT__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::P::FloatT::ice_staticId(), ::P::FloatT::ice_factory());
    }

    ~__F__P__FloatT__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::P::FloatT::ice_staticId());
    }
};

static __F__P__FloatT__Init __F__P__FloatT__i;

#ifdef __APPLE__
extern "C" { void __F__P__FloatT__initializer() {} }
#endif

void 
P::__patch__FloatTPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::P::FloatTPtr* p = static_cast< ::P::FloatTPtr*>(__addr);
    assert(p);
    *p = ::P::FloatTPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::P::FloatT::ice_staticId(), v->ice_id());
    }
}

bool
P::operator==(const ::P::FloatT& l, const ::P::FloatT& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
P::operator<(const ::P::FloatT& l, const ::P::FloatT& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

P::StringT::StringT(const ::std::string& __ice_value) :
    value(__ice_value)
{
}

::Ice::ObjectPtr
P::StringT::ice_clone() const
{
    ::P::StringTPtr __p = new ::P::StringT(*this);
    return __p;
}

static const ::std::string __P__StringT_ids[3] =
{
    "::Ice::Object",
    "::P::StringT",
    "::P::T"
};

bool
P::StringT::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__P__StringT_ids, __P__StringT_ids + 3, _s);
}

::std::vector< ::std::string>
P::StringT::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__P__StringT_ids[0], &__P__StringT_ids[3]);
}

const ::std::string&
P::StringT::ice_id(const ::Ice::Current&) const
{
    return __P__StringT_ids[1];
}

const ::std::string&
P::StringT::ice_staticId()
{
    return __P__StringT_ids[1];
}

void
P::StringT::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(value);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    T::__write(__os);
#else
    ::P::T::__write(__os);
#endif
}

void
P::StringT::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(value);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    T::__read(__is, true);
#else
    ::P::T::__read(__is, true);
#endif
}

void
P::StringT::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type P::StringT was not generated with stream support";
    throw ex;
}

void
P::StringT::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type P::StringT was not generated with stream support";
    throw ex;
}

class __F__P__StringT : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::P::StringT::ice_staticId());
        return new ::P::StringT;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__P__StringT_Ptr = new __F__P__StringT;

const ::Ice::ObjectFactoryPtr&
P::StringT::ice_factory()
{
    return __F__P__StringT_Ptr;
}

class __F__P__StringT__Init
{
public:

    __F__P__StringT__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::P::StringT::ice_staticId(), ::P::StringT::ice_factory());
    }

    ~__F__P__StringT__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::P::StringT::ice_staticId());
    }
};

static __F__P__StringT__Init __F__P__StringT__i;

#ifdef __APPLE__
extern "C" { void __F__P__StringT__initializer() {} }
#endif

void 
P::__patch__StringTPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::P::StringTPtr* p = static_cast< ::P::StringTPtr*>(__addr);
    assert(p);
    *p = ::P::StringTPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::P::StringT::ice_staticId(), v->ice_id());
    }
}

bool
P::operator==(const ::P::StringT& l, const ::P::StringT& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
P::operator<(const ::P::StringT& l, const ::P::StringT& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

P::StringSeqT::StringSeqT(const ::Ice::StringSeq& __ice_value) :
    value(__ice_value)
{
}

::Ice::ObjectPtr
P::StringSeqT::ice_clone() const
{
    ::P::StringSeqTPtr __p = new ::P::StringSeqT(*this);
    return __p;
}

static const ::std::string __P__StringSeqT_ids[3] =
{
    "::Ice::Object",
    "::P::StringSeqT",
    "::P::T"
};

bool
P::StringSeqT::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__P__StringSeqT_ids, __P__StringSeqT_ids + 3, _s);
}

::std::vector< ::std::string>
P::StringSeqT::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__P__StringSeqT_ids[0], &__P__StringSeqT_ids[3]);
}

const ::std::string&
P::StringSeqT::ice_id(const ::Ice::Current&) const
{
    return __P__StringSeqT_ids[1];
}

const ::std::string&
P::StringSeqT::ice_staticId()
{
    return __P__StringSeqT_ids[1];
}

void
P::StringSeqT::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    if(value.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        __os->write(&value[0], &value[0] + value.size());
    }
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    T::__write(__os);
#else
    ::P::T::__write(__os);
#endif
}

void
P::StringSeqT::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(value);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    T::__read(__is, true);
#else
    ::P::T::__read(__is, true);
#endif
}

void
P::StringSeqT::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type P::StringSeqT was not generated with stream support";
    throw ex;
}

void
P::StringSeqT::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type P::StringSeqT was not generated with stream support";
    throw ex;
}

class __F__P__StringSeqT : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::P::StringSeqT::ice_staticId());
        return new ::P::StringSeqT;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__P__StringSeqT_Ptr = new __F__P__StringSeqT;

const ::Ice::ObjectFactoryPtr&
P::StringSeqT::ice_factory()
{
    return __F__P__StringSeqT_Ptr;
}

class __F__P__StringSeqT__Init
{
public:

    __F__P__StringSeqT__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::P::StringSeqT::ice_staticId(), ::P::StringSeqT::ice_factory());
    }

    ~__F__P__StringSeqT__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::P::StringSeqT::ice_staticId());
    }
};

static __F__P__StringSeqT__Init __F__P__StringSeqT__i;

#ifdef __APPLE__
extern "C" { void __F__P__StringSeqT__initializer() {} }
#endif

void 
P::__patch__StringSeqTPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::P::StringSeqTPtr* p = static_cast< ::P::StringSeqTPtr*>(__addr);
    assert(p);
    *p = ::P::StringSeqTPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::P::StringSeqT::ice_staticId(), v->ice_id());
    }
}

bool
P::operator==(const ::P::StringSeqT& l, const ::P::StringSeqT& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
P::operator<(const ::P::StringSeqT& l, const ::P::StringSeqT& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

P::ObjectT::ObjectT(const ::Ice::ObjectPrx& __ice_value) :
    value(__ice_value)
{
}

::Ice::ObjectPtr
P::ObjectT::ice_clone() const
{
    ::P::ObjectTPtr __p = new ::P::ObjectT(*this);
    return __p;
}

static const ::std::string __P__ObjectT_ids[3] =
{
    "::Ice::Object",
    "::P::ObjectT",
    "::P::T"
};

bool
P::ObjectT::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__P__ObjectT_ids, __P__ObjectT_ids + 3, _s);
}

::std::vector< ::std::string>
P::ObjectT::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__P__ObjectT_ids[0], &__P__ObjectT_ids[3]);
}

const ::std::string&
P::ObjectT::ice_id(const ::Ice::Current&) const
{
    return __P__ObjectT_ids[1];
}

const ::std::string&
P::ObjectT::ice_staticId()
{
    return __P__ObjectT_ids[1];
}

void
P::ObjectT::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(value);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    T::__write(__os);
#else
    ::P::T::__write(__os);
#endif
}

void
P::ObjectT::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(value);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    T::__read(__is, true);
#else
    ::P::T::__read(__is, true);
#endif
}

void
P::ObjectT::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type P::ObjectT was not generated with stream support";
    throw ex;
}

void
P::ObjectT::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type P::ObjectT was not generated with stream support";
    throw ex;
}

class __F__P__ObjectT : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::P::ObjectT::ice_staticId());
        return new ::P::ObjectT;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__P__ObjectT_Ptr = new __F__P__ObjectT;

const ::Ice::ObjectFactoryPtr&
P::ObjectT::ice_factory()
{
    return __F__P__ObjectT_Ptr;
}

class __F__P__ObjectT__Init
{
public:

    __F__P__ObjectT__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::P::ObjectT::ice_staticId(), ::P::ObjectT::ice_factory());
    }

    ~__F__P__ObjectT__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::P::ObjectT::ice_staticId());
    }
};

static __F__P__ObjectT__Init __F__P__ObjectT__i;

#ifdef __APPLE__
extern "C" { void __F__P__ObjectT__initializer() {} }
#endif

void 
P::__patch__ObjectTPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::P::ObjectTPtr* p = static_cast< ::P::ObjectTPtr*>(__addr);
    assert(p);
    *p = ::P::ObjectTPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::P::ObjectT::ice_staticId(), v->ice_id());
    }
}

bool
P::operator==(const ::P::ObjectT& l, const ::P::ObjectT& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
P::operator<(const ::P::ObjectT& l, const ::P::ObjectT& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}
