// **********************************************************************
//
// Copyright (c) 2003-2008 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.0
// Generated from file `Shape.ice'

#include <Shape.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 0
#       error Ice patch level mismatch!
#   endif
#endif

::Ice::Object* IceInternal::upCast(::Hesperia::MLP::Shape* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Hesperia::MLP::Shape* p) { return p; }

::Ice::Object* IceInternal::upCast(::Hesperia::MLP::Point* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Hesperia::MLP::Point* p) { return p; }

::Ice::Object* IceInternal::upCast(::Hesperia::MLP::LineString* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Hesperia::MLP::LineString* p) { return p; }

::Ice::Object* IceInternal::upCast(::Hesperia::MLP::Box* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Hesperia::MLP::Box* p) { return p; }

::Ice::Object* IceInternal::upCast(::Hesperia::MLP::LinearRing* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Hesperia::MLP::LinearRing* p) { return p; }

::Ice::Object* IceInternal::upCast(::Hesperia::MLP::PolygonBase* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Hesperia::MLP::PolygonBase* p) { return p; }

::Ice::Object* IceInternal::upCast(::Hesperia::MLP::Polygon* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Hesperia::MLP::Polygon* p) { return p; }

::Ice::Object* IceInternal::upCast(::Hesperia::MLP::CircularArcArea* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Hesperia::MLP::CircularArcArea* p) { return p; }

::Ice::Object* IceInternal::upCast(::Hesperia::MLP::CircularArea* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Hesperia::MLP::CircularArea* p) { return p; }

::Ice::Object* IceInternal::upCast(::Hesperia::MLP::EllipticalArea* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Hesperia::MLP::EllipticalArea* p) { return p; }

::Ice::Object* IceInternal::upCast(::Hesperia::MLP::MultiLineString* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Hesperia::MLP::MultiLineString* p) { return p; }

::Ice::Object* IceInternal::upCast(::Hesperia::MLP::MultiPoint* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Hesperia::MLP::MultiPoint* p) { return p; }

::Ice::Object* IceInternal::upCast(::Hesperia::MLP::MultiPolygon* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Hesperia::MLP::MultiPolygon* p) { return p; }

void
Hesperia::MLP::__read(::IceInternal::BasicStream* __is, ::Hesperia::MLP::ShapePrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Hesperia::MLP::Shape;
        v->__copyFrom(proxy);
    }
}

void
Hesperia::MLP::__read(::IceInternal::BasicStream* __is, ::Hesperia::MLP::PointPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Hesperia::MLP::Point;
        v->__copyFrom(proxy);
    }
}

void
Hesperia::MLP::__read(::IceInternal::BasicStream* __is, ::Hesperia::MLP::LineStringPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Hesperia::MLP::LineString;
        v->__copyFrom(proxy);
    }
}

void
Hesperia::MLP::__read(::IceInternal::BasicStream* __is, ::Hesperia::MLP::BoxPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Hesperia::MLP::Box;
        v->__copyFrom(proxy);
    }
}

void
Hesperia::MLP::__read(::IceInternal::BasicStream* __is, ::Hesperia::MLP::LinearRingPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Hesperia::MLP::LinearRing;
        v->__copyFrom(proxy);
    }
}

void
Hesperia::MLP::__read(::IceInternal::BasicStream* __is, ::Hesperia::MLP::PolygonBasePrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Hesperia::MLP::PolygonBase;
        v->__copyFrom(proxy);
    }
}

void
Hesperia::MLP::__read(::IceInternal::BasicStream* __is, ::Hesperia::MLP::PolygonPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Hesperia::MLP::Polygon;
        v->__copyFrom(proxy);
    }
}

void
Hesperia::MLP::__read(::IceInternal::BasicStream* __is, ::Hesperia::MLP::CircularArcAreaPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Hesperia::MLP::CircularArcArea;
        v->__copyFrom(proxy);
    }
}

void
Hesperia::MLP::__read(::IceInternal::BasicStream* __is, ::Hesperia::MLP::CircularAreaPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Hesperia::MLP::CircularArea;
        v->__copyFrom(proxy);
    }
}

void
Hesperia::MLP::__read(::IceInternal::BasicStream* __is, ::Hesperia::MLP::EllipticalAreaPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Hesperia::MLP::EllipticalArea;
        v->__copyFrom(proxy);
    }
}

void
Hesperia::MLP::__read(::IceInternal::BasicStream* __is, ::Hesperia::MLP::MultiLineStringPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Hesperia::MLP::MultiLineString;
        v->__copyFrom(proxy);
    }
}

void
Hesperia::MLP::__read(::IceInternal::BasicStream* __is, ::Hesperia::MLP::MultiPointPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Hesperia::MLP::MultiPoint;
        v->__copyFrom(proxy);
    }
}

void
Hesperia::MLP::__read(::IceInternal::BasicStream* __is, ::Hesperia::MLP::MultiPolygonPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Hesperia::MLP::MultiPolygon;
        v->__copyFrom(proxy);
    }
}

bool
Hesperia::MLP::Coord::operator==(const Coord& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(x != __rhs.x)
    {
        return false;
    }
    if(y != __rhs.y)
    {
        return false;
    }
    if(z != __rhs.z)
    {
        return false;
    }
    return true;
}

bool
Hesperia::MLP::Coord::operator<(const Coord& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(x < __rhs.x)
    {
        return true;
    }
    else if(__rhs.x < x)
    {
        return false;
    }
    if(y < __rhs.y)
    {
        return true;
    }
    else if(__rhs.y < y)
    {
        return false;
    }
    if(z < __rhs.z)
    {
        return true;
    }
    else if(__rhs.z < z)
    {
        return false;
    }
    return false;
}

void
Hesperia::MLP::Coord::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(x);
    __os->write(y);
    __os->write(z);
}

void
Hesperia::MLP::Coord::__read(::IceInternal::BasicStream* __is)
{
    __is->read(x);
    __is->read(y);
    __is->read(z);
}

void
Hesperia::MLP::__writeCoordSeq(::IceInternal::BasicStream* __os, const ::Hesperia::MLP::Coord* begin, const ::Hesperia::MLP::Coord* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        begin[i].__write(__os);
    }
}

void
Hesperia::MLP::__readCoordSeq(::IceInternal::BasicStream* __is, ::Hesperia::MLP::CoordSeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->checkFixedSeq(sz, 24);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        v[i].__read(__is);
    }
}

void
Hesperia::MLP::__writePointSeq(::IceInternal::BasicStream* __os, const ::Hesperia::MLP::PointPtr* begin, const ::Hesperia::MLP::PointPtr* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        __os->write(::Ice::ObjectPtr(::IceInternal::upCast(begin[i].get())));
    }
}

void
Hesperia::MLP::__readPointSeq(::IceInternal::BasicStream* __is, ::Hesperia::MLP::PointSeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 4);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        __is->read(::Hesperia::MLP::__patch__PointPtr, &v[i]);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

void
Hesperia::MLP::__writeLineStringSeq(::IceInternal::BasicStream* __os, const ::Hesperia::MLP::LineStringPtr* begin, const ::Hesperia::MLP::LineStringPtr* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        __os->write(::Ice::ObjectPtr(::IceInternal::upCast(begin[i].get())));
    }
}

void
Hesperia::MLP::__readLineStringSeq(::IceInternal::BasicStream* __is, ::Hesperia::MLP::LineStringSeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 4);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        __is->read(::Hesperia::MLP::__patch__LineStringPtr, &v[i]);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

void
Hesperia::MLP::__writeLinearRingSeq(::IceInternal::BasicStream* __os, const ::Hesperia::MLP::LinearRingPtr* begin, const ::Hesperia::MLP::LinearRingPtr* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        __os->write(::Ice::ObjectPtr(::IceInternal::upCast(begin[i].get())));
    }
}

void
Hesperia::MLP::__readLinearRingSeq(::IceInternal::BasicStream* __is, ::Hesperia::MLP::LinearRingSeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 4);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        __is->read(::Hesperia::MLP::__patch__LinearRingPtr, &v[i]);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

void
Hesperia::MLP::__writePolygonBaseSeq(::IceInternal::BasicStream* __os, const ::Hesperia::MLP::PolygonBasePtr* begin, const ::Hesperia::MLP::PolygonBasePtr* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        __os->write(::Ice::ObjectPtr(::IceInternal::upCast(begin[i].get())));
    }
}

void
Hesperia::MLP::__readPolygonBaseSeq(::IceInternal::BasicStream* __is, ::Hesperia::MLP::PolygonBaseSeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 4);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        __is->read(::Hesperia::MLP::__patch__PolygonBasePtr, &v[i]);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

const ::std::string&
IceProxy::Hesperia::MLP::Shape::ice_staticId()
{
    return ::Hesperia::MLP::Shape::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Hesperia::MLP::Shape::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Hesperia::MLP::Shape);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Hesperia::MLP::Shape::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Hesperia::MLP::Shape);
}

::IceProxy::Ice::Object*
IceProxy::Hesperia::MLP::Shape::__newInstance() const
{
    return new Shape;
}

const ::std::string&
IceProxy::Hesperia::MLP::Point::ice_staticId()
{
    return ::Hesperia::MLP::Point::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Hesperia::MLP::Point::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Hesperia::MLP::Point);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Hesperia::MLP::Point::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Hesperia::MLP::Point);
}

::IceProxy::Ice::Object*
IceProxy::Hesperia::MLP::Point::__newInstance() const
{
    return new Point;
}

const ::std::string&
IceProxy::Hesperia::MLP::LineString::ice_staticId()
{
    return ::Hesperia::MLP::LineString::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Hesperia::MLP::LineString::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Hesperia::MLP::LineString);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Hesperia::MLP::LineString::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Hesperia::MLP::LineString);
}

::IceProxy::Ice::Object*
IceProxy::Hesperia::MLP::LineString::__newInstance() const
{
    return new LineString;
}

const ::std::string&
IceProxy::Hesperia::MLP::Box::ice_staticId()
{
    return ::Hesperia::MLP::Box::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Hesperia::MLP::Box::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Hesperia::MLP::Box);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Hesperia::MLP::Box::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Hesperia::MLP::Box);
}

::IceProxy::Ice::Object*
IceProxy::Hesperia::MLP::Box::__newInstance() const
{
    return new Box;
}

const ::std::string&
IceProxy::Hesperia::MLP::LinearRing::ice_staticId()
{
    return ::Hesperia::MLP::LinearRing::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Hesperia::MLP::LinearRing::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Hesperia::MLP::LinearRing);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Hesperia::MLP::LinearRing::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Hesperia::MLP::LinearRing);
}

::IceProxy::Ice::Object*
IceProxy::Hesperia::MLP::LinearRing::__newInstance() const
{
    return new LinearRing;
}

const ::std::string&
IceProxy::Hesperia::MLP::PolygonBase::ice_staticId()
{
    return ::Hesperia::MLP::PolygonBase::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Hesperia::MLP::PolygonBase::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Hesperia::MLP::PolygonBase);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Hesperia::MLP::PolygonBase::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Hesperia::MLP::PolygonBase);
}

::IceProxy::Ice::Object*
IceProxy::Hesperia::MLP::PolygonBase::__newInstance() const
{
    return new PolygonBase;
}

const ::std::string&
IceProxy::Hesperia::MLP::Polygon::ice_staticId()
{
    return ::Hesperia::MLP::Polygon::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Hesperia::MLP::Polygon::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Hesperia::MLP::Polygon);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Hesperia::MLP::Polygon::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Hesperia::MLP::Polygon);
}

::IceProxy::Ice::Object*
IceProxy::Hesperia::MLP::Polygon::__newInstance() const
{
    return new Polygon;
}

const ::std::string&
IceProxy::Hesperia::MLP::CircularArcArea::ice_staticId()
{
    return ::Hesperia::MLP::CircularArcArea::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Hesperia::MLP::CircularArcArea::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Hesperia::MLP::CircularArcArea);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Hesperia::MLP::CircularArcArea::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Hesperia::MLP::CircularArcArea);
}

::IceProxy::Ice::Object*
IceProxy::Hesperia::MLP::CircularArcArea::__newInstance() const
{
    return new CircularArcArea;
}

const ::std::string&
IceProxy::Hesperia::MLP::CircularArea::ice_staticId()
{
    return ::Hesperia::MLP::CircularArea::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Hesperia::MLP::CircularArea::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Hesperia::MLP::CircularArea);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Hesperia::MLP::CircularArea::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Hesperia::MLP::CircularArea);
}

::IceProxy::Ice::Object*
IceProxy::Hesperia::MLP::CircularArea::__newInstance() const
{
    return new CircularArea;
}

const ::std::string&
IceProxy::Hesperia::MLP::EllipticalArea::ice_staticId()
{
    return ::Hesperia::MLP::EllipticalArea::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Hesperia::MLP::EllipticalArea::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Hesperia::MLP::EllipticalArea);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Hesperia::MLP::EllipticalArea::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Hesperia::MLP::EllipticalArea);
}

::IceProxy::Ice::Object*
IceProxy::Hesperia::MLP::EllipticalArea::__newInstance() const
{
    return new EllipticalArea;
}

const ::std::string&
IceProxy::Hesperia::MLP::MultiLineString::ice_staticId()
{
    return ::Hesperia::MLP::MultiLineString::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Hesperia::MLP::MultiLineString::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Hesperia::MLP::MultiLineString);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Hesperia::MLP::MultiLineString::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Hesperia::MLP::MultiLineString);
}

::IceProxy::Ice::Object*
IceProxy::Hesperia::MLP::MultiLineString::__newInstance() const
{
    return new MultiLineString;
}

const ::std::string&
IceProxy::Hesperia::MLP::MultiPoint::ice_staticId()
{
    return ::Hesperia::MLP::MultiPoint::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Hesperia::MLP::MultiPoint::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Hesperia::MLP::MultiPoint);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Hesperia::MLP::MultiPoint::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Hesperia::MLP::MultiPoint);
}

::IceProxy::Ice::Object*
IceProxy::Hesperia::MLP::MultiPoint::__newInstance() const
{
    return new MultiPoint;
}

const ::std::string&
IceProxy::Hesperia::MLP::MultiPolygon::ice_staticId()
{
    return ::Hesperia::MLP::MultiPolygon::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Hesperia::MLP::MultiPolygon::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Hesperia::MLP::MultiPolygon);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Hesperia::MLP::MultiPolygon::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Hesperia::MLP::MultiPolygon);
}

::IceProxy::Ice::Object*
IceProxy::Hesperia::MLP::MultiPolygon::__newInstance() const
{
    return new MultiPolygon;
}

::Ice::ObjectPtr
Hesperia::MLP::Shape::ice_clone() const
{
    ::Hesperia::MLP::ShapePtr __p = new ::Hesperia::MLP::Shape(*this);
    return __p;
}

static const ::std::string __Hesperia__MLP__Shape_ids[3] =
{
    "::Hesperia::MLP::Shape",
    "::Ice::Object",
    "::P::T"
};

bool
Hesperia::MLP::Shape::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Hesperia__MLP__Shape_ids, __Hesperia__MLP__Shape_ids + 3, _s);
}

::std::vector< ::std::string>
Hesperia::MLP::Shape::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Hesperia__MLP__Shape_ids[0], &__Hesperia__MLP__Shape_ids[3]);
}

const ::std::string&
Hesperia::MLP::Shape::ice_id(const ::Ice::Current&) const
{
    return __Hesperia__MLP__Shape_ids[0];
}

const ::std::string&
Hesperia::MLP::Shape::ice_staticId()
{
    return __Hesperia__MLP__Shape_ids[0];
}

void
Hesperia::MLP::Shape::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    T::__write(__os);
#else
    ::P::T::__write(__os);
#endif
}

void
Hesperia::MLP::Shape::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    T::__read(__is, true);
#else
    ::P::T::__read(__is, true);
#endif
}

void
Hesperia::MLP::Shape::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::Shape was not generated with stream support";
    throw ex;
}

void
Hesperia::MLP::Shape::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::Shape was not generated with stream support";
    throw ex;
}

class __F__Hesperia__MLP__Shape : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::Hesperia::MLP::Shape::ice_staticId());
        return new ::Hesperia::MLP::Shape;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__Hesperia__MLP__Shape_Ptr = new __F__Hesperia__MLP__Shape;

const ::Ice::ObjectFactoryPtr&
Hesperia::MLP::Shape::ice_factory()
{
    return __F__Hesperia__MLP__Shape_Ptr;
}

class __F__Hesperia__MLP__Shape__Init
{
public:

    __F__Hesperia__MLP__Shape__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::Hesperia::MLP::Shape::ice_staticId(), ::Hesperia::MLP::Shape::ice_factory());
    }

    ~__F__Hesperia__MLP__Shape__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::Hesperia::MLP::Shape::ice_staticId());
    }
};

static __F__Hesperia__MLP__Shape__Init __F__Hesperia__MLP__Shape__i;

#ifdef __APPLE__
extern "C" { void __F__Hesperia__MLP__Shape__initializer() {} }
#endif

void 
Hesperia::MLP::__patch__ShapePtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Hesperia::MLP::ShapePtr* p = static_cast< ::Hesperia::MLP::ShapePtr*>(__addr);
    assert(p);
    *p = ::Hesperia::MLP::ShapePtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Hesperia::MLP::Shape::ice_staticId(), v->ice_id());
    }
}

bool
Hesperia::MLP::operator==(const ::Hesperia::MLP::Shape& l, const ::Hesperia::MLP::Shape& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Hesperia::MLP::operator<(const ::Hesperia::MLP::Shape& l, const ::Hesperia::MLP::Shape& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

Hesperia::MLP::Point::Point(const ::Hesperia::MLP::Coord& __ice_center) :
    center(__ice_center)
{
}

::Ice::ObjectPtr
Hesperia::MLP::Point::ice_clone() const
{
    ::Hesperia::MLP::PointPtr __p = new ::Hesperia::MLP::Point(*this);
    return __p;
}

static const ::std::string __Hesperia__MLP__Point_ids[4] =
{
    "::Hesperia::MLP::Point",
    "::Hesperia::MLP::Shape",
    "::Ice::Object",
    "::P::T"
};

bool
Hesperia::MLP::Point::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Hesperia__MLP__Point_ids, __Hesperia__MLP__Point_ids + 4, _s);
}

::std::vector< ::std::string>
Hesperia::MLP::Point::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Hesperia__MLP__Point_ids[0], &__Hesperia__MLP__Point_ids[4]);
}

const ::std::string&
Hesperia::MLP::Point::ice_id(const ::Ice::Current&) const
{
    return __Hesperia__MLP__Point_ids[0];
}

const ::std::string&
Hesperia::MLP::Point::ice_staticId()
{
    return __Hesperia__MLP__Point_ids[0];
}

void
Hesperia::MLP::Point::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    center.__write(__os);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Shape::__write(__os);
#else
    ::Hesperia::MLP::Shape::__write(__os);
#endif
}

void
Hesperia::MLP::Point::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    center.__read(__is);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Shape::__read(__is, true);
#else
    ::Hesperia::MLP::Shape::__read(__is, true);
#endif
}

void
Hesperia::MLP::Point::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::Point was not generated with stream support";
    throw ex;
}

void
Hesperia::MLP::Point::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::Point was not generated with stream support";
    throw ex;
}

class __F__Hesperia__MLP__Point : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::Hesperia::MLP::Point::ice_staticId());
        return new ::Hesperia::MLP::Point;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__Hesperia__MLP__Point_Ptr = new __F__Hesperia__MLP__Point;

const ::Ice::ObjectFactoryPtr&
Hesperia::MLP::Point::ice_factory()
{
    return __F__Hesperia__MLP__Point_Ptr;
}

class __F__Hesperia__MLP__Point__Init
{
public:

    __F__Hesperia__MLP__Point__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::Hesperia::MLP::Point::ice_staticId(), ::Hesperia::MLP::Point::ice_factory());
    }

    ~__F__Hesperia__MLP__Point__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::Hesperia::MLP::Point::ice_staticId());
    }
};

static __F__Hesperia__MLP__Point__Init __F__Hesperia__MLP__Point__i;

#ifdef __APPLE__
extern "C" { void __F__Hesperia__MLP__Point__initializer() {} }
#endif

void 
Hesperia::MLP::__patch__PointPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Hesperia::MLP::PointPtr* p = static_cast< ::Hesperia::MLP::PointPtr*>(__addr);
    assert(p);
    *p = ::Hesperia::MLP::PointPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Hesperia::MLP::Point::ice_staticId(), v->ice_id());
    }
}

bool
Hesperia::MLP::operator==(const ::Hesperia::MLP::Point& l, const ::Hesperia::MLP::Point& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Hesperia::MLP::operator<(const ::Hesperia::MLP::Point& l, const ::Hesperia::MLP::Point& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

Hesperia::MLP::LineString::LineString(const ::Hesperia::MLP::CoordSeq& __ice_points) :
    points(__ice_points)
{
}

::Ice::ObjectPtr
Hesperia::MLP::LineString::ice_clone() const
{
    ::Hesperia::MLP::LineStringPtr __p = new ::Hesperia::MLP::LineString(*this);
    return __p;
}

static const ::std::string __Hesperia__MLP__LineString_ids[4] =
{
    "::Hesperia::MLP::LineString",
    "::Hesperia::MLP::Shape",
    "::Ice::Object",
    "::P::T"
};

bool
Hesperia::MLP::LineString::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Hesperia__MLP__LineString_ids, __Hesperia__MLP__LineString_ids + 4, _s);
}

::std::vector< ::std::string>
Hesperia::MLP::LineString::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Hesperia__MLP__LineString_ids[0], &__Hesperia__MLP__LineString_ids[4]);
}

const ::std::string&
Hesperia::MLP::LineString::ice_id(const ::Ice::Current&) const
{
    return __Hesperia__MLP__LineString_ids[0];
}

const ::std::string&
Hesperia::MLP::LineString::ice_staticId()
{
    return __Hesperia__MLP__LineString_ids[0];
}

void
Hesperia::MLP::LineString::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    if(points.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::Hesperia::MLP::__writeCoordSeq(__os, &points[0], &points[0] + points.size());
    }
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Shape::__write(__os);
#else
    ::Hesperia::MLP::Shape::__write(__os);
#endif
}

void
Hesperia::MLP::LineString::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    ::Hesperia::MLP::__readCoordSeq(__is, points);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Shape::__read(__is, true);
#else
    ::Hesperia::MLP::Shape::__read(__is, true);
#endif
}

void
Hesperia::MLP::LineString::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::LineString was not generated with stream support";
    throw ex;
}

void
Hesperia::MLP::LineString::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::LineString was not generated with stream support";
    throw ex;
}

class __F__Hesperia__MLP__LineString : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::Hesperia::MLP::LineString::ice_staticId());
        return new ::Hesperia::MLP::LineString;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__Hesperia__MLP__LineString_Ptr = new __F__Hesperia__MLP__LineString;

const ::Ice::ObjectFactoryPtr&
Hesperia::MLP::LineString::ice_factory()
{
    return __F__Hesperia__MLP__LineString_Ptr;
}

class __F__Hesperia__MLP__LineString__Init
{
public:

    __F__Hesperia__MLP__LineString__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::Hesperia::MLP::LineString::ice_staticId(), ::Hesperia::MLP::LineString::ice_factory());
    }

    ~__F__Hesperia__MLP__LineString__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::Hesperia::MLP::LineString::ice_staticId());
    }
};

static __F__Hesperia__MLP__LineString__Init __F__Hesperia__MLP__LineString__i;

#ifdef __APPLE__
extern "C" { void __F__Hesperia__MLP__LineString__initializer() {} }
#endif

void 
Hesperia::MLP::__patch__LineStringPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Hesperia::MLP::LineStringPtr* p = static_cast< ::Hesperia::MLP::LineStringPtr*>(__addr);
    assert(p);
    *p = ::Hesperia::MLP::LineStringPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Hesperia::MLP::LineString::ice_staticId(), v->ice_id());
    }
}

bool
Hesperia::MLP::operator==(const ::Hesperia::MLP::LineString& l, const ::Hesperia::MLP::LineString& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Hesperia::MLP::operator<(const ::Hesperia::MLP::LineString& l, const ::Hesperia::MLP::LineString& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

Hesperia::MLP::Box::Box(const ::Hesperia::MLP::Coord& __ice_topLeft, const ::Hesperia::MLP::Coord& __ice_bottomRight) :
    topLeft(__ice_topLeft),
    bottomRight(__ice_bottomRight)
{
}

::Ice::ObjectPtr
Hesperia::MLP::Box::ice_clone() const
{
    ::Hesperia::MLP::BoxPtr __p = new ::Hesperia::MLP::Box(*this);
    return __p;
}

static const ::std::string __Hesperia__MLP__Box_ids[4] =
{
    "::Hesperia::MLP::Box",
    "::Hesperia::MLP::Shape",
    "::Ice::Object",
    "::P::T"
};

bool
Hesperia::MLP::Box::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Hesperia__MLP__Box_ids, __Hesperia__MLP__Box_ids + 4, _s);
}

::std::vector< ::std::string>
Hesperia::MLP::Box::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Hesperia__MLP__Box_ids[0], &__Hesperia__MLP__Box_ids[4]);
}

const ::std::string&
Hesperia::MLP::Box::ice_id(const ::Ice::Current&) const
{
    return __Hesperia__MLP__Box_ids[0];
}

const ::std::string&
Hesperia::MLP::Box::ice_staticId()
{
    return __Hesperia__MLP__Box_ids[0];
}

void
Hesperia::MLP::Box::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    topLeft.__write(__os);
    bottomRight.__write(__os);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Shape::__write(__os);
#else
    ::Hesperia::MLP::Shape::__write(__os);
#endif
}

void
Hesperia::MLP::Box::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    topLeft.__read(__is);
    bottomRight.__read(__is);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Shape::__read(__is, true);
#else
    ::Hesperia::MLP::Shape::__read(__is, true);
#endif
}

void
Hesperia::MLP::Box::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::Box was not generated with stream support";
    throw ex;
}

void
Hesperia::MLP::Box::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::Box was not generated with stream support";
    throw ex;
}

class __F__Hesperia__MLP__Box : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::Hesperia::MLP::Box::ice_staticId());
        return new ::Hesperia::MLP::Box;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__Hesperia__MLP__Box_Ptr = new __F__Hesperia__MLP__Box;

const ::Ice::ObjectFactoryPtr&
Hesperia::MLP::Box::ice_factory()
{
    return __F__Hesperia__MLP__Box_Ptr;
}

class __F__Hesperia__MLP__Box__Init
{
public:

    __F__Hesperia__MLP__Box__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::Hesperia::MLP::Box::ice_staticId(), ::Hesperia::MLP::Box::ice_factory());
    }

    ~__F__Hesperia__MLP__Box__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::Hesperia::MLP::Box::ice_staticId());
    }
};

static __F__Hesperia__MLP__Box__Init __F__Hesperia__MLP__Box__i;

#ifdef __APPLE__
extern "C" { void __F__Hesperia__MLP__Box__initializer() {} }
#endif

void 
Hesperia::MLP::__patch__BoxPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Hesperia::MLP::BoxPtr* p = static_cast< ::Hesperia::MLP::BoxPtr*>(__addr);
    assert(p);
    *p = ::Hesperia::MLP::BoxPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Hesperia::MLP::Box::ice_staticId(), v->ice_id());
    }
}

bool
Hesperia::MLP::operator==(const ::Hesperia::MLP::Box& l, const ::Hesperia::MLP::Box& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Hesperia::MLP::operator<(const ::Hesperia::MLP::Box& l, const ::Hesperia::MLP::Box& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

Hesperia::MLP::LinearRing::LinearRing(const ::Hesperia::MLP::CoordSeq& __ice_points) :
    points(__ice_points)
{
}

::Ice::ObjectPtr
Hesperia::MLP::LinearRing::ice_clone() const
{
    ::Hesperia::MLP::LinearRingPtr __p = new ::Hesperia::MLP::LinearRing(*this);
    return __p;
}

static const ::std::string __Hesperia__MLP__LinearRing_ids[4] =
{
    "::Hesperia::MLP::LinearRing",
    "::Hesperia::MLP::Shape",
    "::Ice::Object",
    "::P::T"
};

bool
Hesperia::MLP::LinearRing::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Hesperia__MLP__LinearRing_ids, __Hesperia__MLP__LinearRing_ids + 4, _s);
}

::std::vector< ::std::string>
Hesperia::MLP::LinearRing::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Hesperia__MLP__LinearRing_ids[0], &__Hesperia__MLP__LinearRing_ids[4]);
}

const ::std::string&
Hesperia::MLP::LinearRing::ice_id(const ::Ice::Current&) const
{
    return __Hesperia__MLP__LinearRing_ids[0];
}

const ::std::string&
Hesperia::MLP::LinearRing::ice_staticId()
{
    return __Hesperia__MLP__LinearRing_ids[0];
}

void
Hesperia::MLP::LinearRing::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    if(points.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::Hesperia::MLP::__writeCoordSeq(__os, &points[0], &points[0] + points.size());
    }
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Shape::__write(__os);
#else
    ::Hesperia::MLP::Shape::__write(__os);
#endif
}

void
Hesperia::MLP::LinearRing::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    ::Hesperia::MLP::__readCoordSeq(__is, points);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Shape::__read(__is, true);
#else
    ::Hesperia::MLP::Shape::__read(__is, true);
#endif
}

void
Hesperia::MLP::LinearRing::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::LinearRing was not generated with stream support";
    throw ex;
}

void
Hesperia::MLP::LinearRing::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::LinearRing was not generated with stream support";
    throw ex;
}

class __F__Hesperia__MLP__LinearRing : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::Hesperia::MLP::LinearRing::ice_staticId());
        return new ::Hesperia::MLP::LinearRing;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__Hesperia__MLP__LinearRing_Ptr = new __F__Hesperia__MLP__LinearRing;

const ::Ice::ObjectFactoryPtr&
Hesperia::MLP::LinearRing::ice_factory()
{
    return __F__Hesperia__MLP__LinearRing_Ptr;
}

class __F__Hesperia__MLP__LinearRing__Init
{
public:

    __F__Hesperia__MLP__LinearRing__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::Hesperia::MLP::LinearRing::ice_staticId(), ::Hesperia::MLP::LinearRing::ice_factory());
    }

    ~__F__Hesperia__MLP__LinearRing__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::Hesperia::MLP::LinearRing::ice_staticId());
    }
};

static __F__Hesperia__MLP__LinearRing__Init __F__Hesperia__MLP__LinearRing__i;

#ifdef __APPLE__
extern "C" { void __F__Hesperia__MLP__LinearRing__initializer() {} }
#endif

void 
Hesperia::MLP::__patch__LinearRingPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Hesperia::MLP::LinearRingPtr* p = static_cast< ::Hesperia::MLP::LinearRingPtr*>(__addr);
    assert(p);
    *p = ::Hesperia::MLP::LinearRingPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Hesperia::MLP::LinearRing::ice_staticId(), v->ice_id());
    }
}

bool
Hesperia::MLP::operator==(const ::Hesperia::MLP::LinearRing& l, const ::Hesperia::MLP::LinearRing& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Hesperia::MLP::operator<(const ::Hesperia::MLP::LinearRing& l, const ::Hesperia::MLP::LinearRing& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
Hesperia::MLP::PolygonBase::ice_clone() const
{
    ::Hesperia::MLP::PolygonBasePtr __p = new ::Hesperia::MLP::PolygonBase(*this);
    return __p;
}

static const ::std::string __Hesperia__MLP__PolygonBase_ids[4] =
{
    "::Hesperia::MLP::PolygonBase",
    "::Hesperia::MLP::Shape",
    "::Ice::Object",
    "::P::T"
};

bool
Hesperia::MLP::PolygonBase::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Hesperia__MLP__PolygonBase_ids, __Hesperia__MLP__PolygonBase_ids + 4, _s);
}

::std::vector< ::std::string>
Hesperia::MLP::PolygonBase::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Hesperia__MLP__PolygonBase_ids[0], &__Hesperia__MLP__PolygonBase_ids[4]);
}

const ::std::string&
Hesperia::MLP::PolygonBase::ice_id(const ::Ice::Current&) const
{
    return __Hesperia__MLP__PolygonBase_ids[0];
}

const ::std::string&
Hesperia::MLP::PolygonBase::ice_staticId()
{
    return __Hesperia__MLP__PolygonBase_ids[0];
}

void
Hesperia::MLP::PolygonBase::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Shape::__write(__os);
#else
    ::Hesperia::MLP::Shape::__write(__os);
#endif
}

void
Hesperia::MLP::PolygonBase::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Shape::__read(__is, true);
#else
    ::Hesperia::MLP::Shape::__read(__is, true);
#endif
}

void
Hesperia::MLP::PolygonBase::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::PolygonBase was not generated with stream support";
    throw ex;
}

void
Hesperia::MLP::PolygonBase::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::PolygonBase was not generated with stream support";
    throw ex;
}

class __F__Hesperia__MLP__PolygonBase : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::Hesperia::MLP::PolygonBase::ice_staticId());
        return new ::Hesperia::MLP::PolygonBase;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__Hesperia__MLP__PolygonBase_Ptr = new __F__Hesperia__MLP__PolygonBase;

const ::Ice::ObjectFactoryPtr&
Hesperia::MLP::PolygonBase::ice_factory()
{
    return __F__Hesperia__MLP__PolygonBase_Ptr;
}

class __F__Hesperia__MLP__PolygonBase__Init
{
public:

    __F__Hesperia__MLP__PolygonBase__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::Hesperia::MLP::PolygonBase::ice_staticId(), ::Hesperia::MLP::PolygonBase::ice_factory());
    }

    ~__F__Hesperia__MLP__PolygonBase__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::Hesperia::MLP::PolygonBase::ice_staticId());
    }
};

static __F__Hesperia__MLP__PolygonBase__Init __F__Hesperia__MLP__PolygonBase__i;

#ifdef __APPLE__
extern "C" { void __F__Hesperia__MLP__PolygonBase__initializer() {} }
#endif

void 
Hesperia::MLP::__patch__PolygonBasePtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Hesperia::MLP::PolygonBasePtr* p = static_cast< ::Hesperia::MLP::PolygonBasePtr*>(__addr);
    assert(p);
    *p = ::Hesperia::MLP::PolygonBasePtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Hesperia::MLP::PolygonBase::ice_staticId(), v->ice_id());
    }
}

bool
Hesperia::MLP::operator==(const ::Hesperia::MLP::PolygonBase& l, const ::Hesperia::MLP::PolygonBase& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Hesperia::MLP::operator<(const ::Hesperia::MLP::PolygonBase& l, const ::Hesperia::MLP::PolygonBase& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

Hesperia::MLP::Polygon::Polygon(const ::Hesperia::MLP::LinearRingPtr& __ice_outerBoundaryIs, const ::Hesperia::MLP::LinearRingSeq& __ice_innerBoundaryIs) :
    outerBoundaryIs(__ice_outerBoundaryIs),
    innerBoundaryIs(__ice_innerBoundaryIs)
{
}

::Ice::ObjectPtr
Hesperia::MLP::Polygon::ice_clone() const
{
    ::Hesperia::MLP::PolygonPtr __p = new ::Hesperia::MLP::Polygon(*this);
    return __p;
}

static const ::std::string __Hesperia__MLP__Polygon_ids[5] =
{
    "::Hesperia::MLP::Polygon",
    "::Hesperia::MLP::PolygonBase",
    "::Hesperia::MLP::Shape",
    "::Ice::Object",
    "::P::T"
};

bool
Hesperia::MLP::Polygon::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Hesperia__MLP__Polygon_ids, __Hesperia__MLP__Polygon_ids + 5, _s);
}

::std::vector< ::std::string>
Hesperia::MLP::Polygon::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Hesperia__MLP__Polygon_ids[0], &__Hesperia__MLP__Polygon_ids[5]);
}

const ::std::string&
Hesperia::MLP::Polygon::ice_id(const ::Ice::Current&) const
{
    return __Hesperia__MLP__Polygon_ids[0];
}

const ::std::string&
Hesperia::MLP::Polygon::ice_staticId()
{
    return __Hesperia__MLP__Polygon_ids[0];
}

void
Hesperia::MLP::Polygon::__incRef()
{
    __gcIncRef();
}

void
Hesperia::MLP::Polygon::__decRef()
{
    __gcDecRef();
}

void
Hesperia::MLP::Polygon::__addObject(::IceInternal::GCCountMap& _c)
{
    ::IceInternal::GCCountMap::iterator pos = _c.find(this);
    if(pos == _c.end())
    {
        _c[this] = 1;
    }
    else
    {
        ++pos->second;
    }
}

bool
Hesperia::MLP::Polygon::__usesClasses()
{
    return true;
}

void
Hesperia::MLP::Polygon::__gcReachable(::IceInternal::GCCountMap& _c) const
{
    if(outerBoundaryIs)
    {
        ::IceInternal::upCast(outerBoundaryIs.get())->__addObject(_c);
    }
    {
        for(::Hesperia::MLP::LinearRingSeq::const_iterator _i0 = innerBoundaryIs.begin(); _i0 != innerBoundaryIs.end(); ++_i0)
        {
            if((*_i0))
            {
                ::IceInternal::upCast((*_i0).get())->__addObject(_c);
            }
        }
    }
}

void
Hesperia::MLP::Polygon::__gcClear()
{
    if(outerBoundaryIs)
    {
        if(::IceInternal::upCast(outerBoundaryIs.get())->__usesClasses())
        {
            ::IceInternal::upCast(outerBoundaryIs.get())->__decRefUnsafe();
            outerBoundaryIs.__clearHandleUnsafe();
        }
        else
        {
            outerBoundaryIs = 0;
        }
    }
    {
        for(::Hesperia::MLP::LinearRingSeq::iterator _i0 = innerBoundaryIs.begin(); _i0 != innerBoundaryIs.end(); ++_i0)
        {
            if((*_i0))
            {
                if(::IceInternal::upCast((*_i0).get())->__usesClasses())
                {
                    ::IceInternal::upCast((*_i0).get())->__decRefUnsafe();
                    (*_i0).__clearHandleUnsafe();
                }
                else
                {
                    (*_i0) = 0;
                }
            }
        }
    }
}

void
Hesperia::MLP::Polygon::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->write(::Ice::ObjectPtr(::IceInternal::upCast(outerBoundaryIs.get())));
    if(innerBoundaryIs.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::Hesperia::MLP::__writeLinearRingSeq(__os, &innerBoundaryIs[0], &innerBoundaryIs[0] + innerBoundaryIs.size());
    }
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    PolygonBase::__write(__os);
#else
    ::Hesperia::MLP::PolygonBase::__write(__os);
#endif
}

void
Hesperia::MLP::Polygon::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->read(::Hesperia::MLP::__patch__LinearRingPtr, &outerBoundaryIs);
    ::Hesperia::MLP::__readLinearRingSeq(__is, innerBoundaryIs);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    PolygonBase::__read(__is, true);
#else
    ::Hesperia::MLP::PolygonBase::__read(__is, true);
#endif
}

void
Hesperia::MLP::Polygon::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::Polygon was not generated with stream support";
    throw ex;
}

void
Hesperia::MLP::Polygon::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::Polygon was not generated with stream support";
    throw ex;
}

class __F__Hesperia__MLP__Polygon : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::Hesperia::MLP::Polygon::ice_staticId());
        return new ::Hesperia::MLP::Polygon;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__Hesperia__MLP__Polygon_Ptr = new __F__Hesperia__MLP__Polygon;

const ::Ice::ObjectFactoryPtr&
Hesperia::MLP::Polygon::ice_factory()
{
    return __F__Hesperia__MLP__Polygon_Ptr;
}

class __F__Hesperia__MLP__Polygon__Init
{
public:

    __F__Hesperia__MLP__Polygon__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::Hesperia::MLP::Polygon::ice_staticId(), ::Hesperia::MLP::Polygon::ice_factory());
    }

    ~__F__Hesperia__MLP__Polygon__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::Hesperia::MLP::Polygon::ice_staticId());
    }
};

static __F__Hesperia__MLP__Polygon__Init __F__Hesperia__MLP__Polygon__i;

#ifdef __APPLE__
extern "C" { void __F__Hesperia__MLP__Polygon__initializer() {} }
#endif

void 
Hesperia::MLP::__patch__PolygonPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Hesperia::MLP::PolygonPtr* p = static_cast< ::Hesperia::MLP::PolygonPtr*>(__addr);
    assert(p);
    *p = ::Hesperia::MLP::PolygonPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Hesperia::MLP::Polygon::ice_staticId(), v->ice_id());
    }
}

bool
Hesperia::MLP::operator==(const ::Hesperia::MLP::Polygon& l, const ::Hesperia::MLP::Polygon& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Hesperia::MLP::operator<(const ::Hesperia::MLP::Polygon& l, const ::Hesperia::MLP::Polygon& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

Hesperia::MLP::CircularArcArea::CircularArcArea(const ::Hesperia::MLP::Coord& __ice_center, ::Ice::Double __ice_inRadius, ::Ice::Double __ice_outRadius, ::Ice::Double __ice_startAngle, ::Ice::Double __ice_stopAngle) :
    center(__ice_center),
    inRadius(__ice_inRadius),
    outRadius(__ice_outRadius),
    startAngle(__ice_startAngle),
    stopAngle(__ice_stopAngle)
{
}

::Ice::ObjectPtr
Hesperia::MLP::CircularArcArea::ice_clone() const
{
    ::Hesperia::MLP::CircularArcAreaPtr __p = new ::Hesperia::MLP::CircularArcArea(*this);
    return __p;
}

static const ::std::string __Hesperia__MLP__CircularArcArea_ids[5] =
{
    "::Hesperia::MLP::CircularArcArea",
    "::Hesperia::MLP::PolygonBase",
    "::Hesperia::MLP::Shape",
    "::Ice::Object",
    "::P::T"
};

bool
Hesperia::MLP::CircularArcArea::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Hesperia__MLP__CircularArcArea_ids, __Hesperia__MLP__CircularArcArea_ids + 5, _s);
}

::std::vector< ::std::string>
Hesperia::MLP::CircularArcArea::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Hesperia__MLP__CircularArcArea_ids[0], &__Hesperia__MLP__CircularArcArea_ids[5]);
}

const ::std::string&
Hesperia::MLP::CircularArcArea::ice_id(const ::Ice::Current&) const
{
    return __Hesperia__MLP__CircularArcArea_ids[0];
}

const ::std::string&
Hesperia::MLP::CircularArcArea::ice_staticId()
{
    return __Hesperia__MLP__CircularArcArea_ids[0];
}

void
Hesperia::MLP::CircularArcArea::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    center.__write(__os);
    __os->write(inRadius);
    __os->write(outRadius);
    __os->write(startAngle);
    __os->write(stopAngle);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    PolygonBase::__write(__os);
#else
    ::Hesperia::MLP::PolygonBase::__write(__os);
#endif
}

void
Hesperia::MLP::CircularArcArea::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    center.__read(__is);
    __is->read(inRadius);
    __is->read(outRadius);
    __is->read(startAngle);
    __is->read(stopAngle);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    PolygonBase::__read(__is, true);
#else
    ::Hesperia::MLP::PolygonBase::__read(__is, true);
#endif
}

void
Hesperia::MLP::CircularArcArea::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::CircularArcArea was not generated with stream support";
    throw ex;
}

void
Hesperia::MLP::CircularArcArea::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::CircularArcArea was not generated with stream support";
    throw ex;
}

class __F__Hesperia__MLP__CircularArcArea : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::Hesperia::MLP::CircularArcArea::ice_staticId());
        return new ::Hesperia::MLP::CircularArcArea;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__Hesperia__MLP__CircularArcArea_Ptr = new __F__Hesperia__MLP__CircularArcArea;

const ::Ice::ObjectFactoryPtr&
Hesperia::MLP::CircularArcArea::ice_factory()
{
    return __F__Hesperia__MLP__CircularArcArea_Ptr;
}

class __F__Hesperia__MLP__CircularArcArea__Init
{
public:

    __F__Hesperia__MLP__CircularArcArea__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::Hesperia::MLP::CircularArcArea::ice_staticId(), ::Hesperia::MLP::CircularArcArea::ice_factory());
    }

    ~__F__Hesperia__MLP__CircularArcArea__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::Hesperia::MLP::CircularArcArea::ice_staticId());
    }
};

static __F__Hesperia__MLP__CircularArcArea__Init __F__Hesperia__MLP__CircularArcArea__i;

#ifdef __APPLE__
extern "C" { void __F__Hesperia__MLP__CircularArcArea__initializer() {} }
#endif

void 
Hesperia::MLP::__patch__CircularArcAreaPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Hesperia::MLP::CircularArcAreaPtr* p = static_cast< ::Hesperia::MLP::CircularArcAreaPtr*>(__addr);
    assert(p);
    *p = ::Hesperia::MLP::CircularArcAreaPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Hesperia::MLP::CircularArcArea::ice_staticId(), v->ice_id());
    }
}

bool
Hesperia::MLP::operator==(const ::Hesperia::MLP::CircularArcArea& l, const ::Hesperia::MLP::CircularArcArea& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Hesperia::MLP::operator<(const ::Hesperia::MLP::CircularArcArea& l, const ::Hesperia::MLP::CircularArcArea& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

Hesperia::MLP::CircularArea::CircularArea(const ::Hesperia::MLP::Coord& __ice_center, ::Ice::Double __ice_radius) :
    center(__ice_center),
    radius(__ice_radius)
{
}

::Ice::ObjectPtr
Hesperia::MLP::CircularArea::ice_clone() const
{
    ::Hesperia::MLP::CircularAreaPtr __p = new ::Hesperia::MLP::CircularArea(*this);
    return __p;
}

static const ::std::string __Hesperia__MLP__CircularArea_ids[5] =
{
    "::Hesperia::MLP::CircularArea",
    "::Hesperia::MLP::PolygonBase",
    "::Hesperia::MLP::Shape",
    "::Ice::Object",
    "::P::T"
};

bool
Hesperia::MLP::CircularArea::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Hesperia__MLP__CircularArea_ids, __Hesperia__MLP__CircularArea_ids + 5, _s);
}

::std::vector< ::std::string>
Hesperia::MLP::CircularArea::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Hesperia__MLP__CircularArea_ids[0], &__Hesperia__MLP__CircularArea_ids[5]);
}

const ::std::string&
Hesperia::MLP::CircularArea::ice_id(const ::Ice::Current&) const
{
    return __Hesperia__MLP__CircularArea_ids[0];
}

const ::std::string&
Hesperia::MLP::CircularArea::ice_staticId()
{
    return __Hesperia__MLP__CircularArea_ids[0];
}

void
Hesperia::MLP::CircularArea::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    center.__write(__os);
    __os->write(radius);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    PolygonBase::__write(__os);
#else
    ::Hesperia::MLP::PolygonBase::__write(__os);
#endif
}

void
Hesperia::MLP::CircularArea::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    center.__read(__is);
    __is->read(radius);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    PolygonBase::__read(__is, true);
#else
    ::Hesperia::MLP::PolygonBase::__read(__is, true);
#endif
}

void
Hesperia::MLP::CircularArea::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::CircularArea was not generated with stream support";
    throw ex;
}

void
Hesperia::MLP::CircularArea::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::CircularArea was not generated with stream support";
    throw ex;
}

class __F__Hesperia__MLP__CircularArea : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::Hesperia::MLP::CircularArea::ice_staticId());
        return new ::Hesperia::MLP::CircularArea;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__Hesperia__MLP__CircularArea_Ptr = new __F__Hesperia__MLP__CircularArea;

const ::Ice::ObjectFactoryPtr&
Hesperia::MLP::CircularArea::ice_factory()
{
    return __F__Hesperia__MLP__CircularArea_Ptr;
}

class __F__Hesperia__MLP__CircularArea__Init
{
public:

    __F__Hesperia__MLP__CircularArea__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::Hesperia::MLP::CircularArea::ice_staticId(), ::Hesperia::MLP::CircularArea::ice_factory());
    }

    ~__F__Hesperia__MLP__CircularArea__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::Hesperia::MLP::CircularArea::ice_staticId());
    }
};

static __F__Hesperia__MLP__CircularArea__Init __F__Hesperia__MLP__CircularArea__i;

#ifdef __APPLE__
extern "C" { void __F__Hesperia__MLP__CircularArea__initializer() {} }
#endif

void 
Hesperia::MLP::__patch__CircularAreaPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Hesperia::MLP::CircularAreaPtr* p = static_cast< ::Hesperia::MLP::CircularAreaPtr*>(__addr);
    assert(p);
    *p = ::Hesperia::MLP::CircularAreaPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Hesperia::MLP::CircularArea::ice_staticId(), v->ice_id());
    }
}

bool
Hesperia::MLP::operator==(const ::Hesperia::MLP::CircularArea& l, const ::Hesperia::MLP::CircularArea& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Hesperia::MLP::operator<(const ::Hesperia::MLP::CircularArea& l, const ::Hesperia::MLP::CircularArea& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

Hesperia::MLP::EllipticalArea::EllipticalArea(const ::Hesperia::MLP::Coord& __ice_center, ::Ice::Double __ice_angle, ::Ice::Double __ice_semiMinor, ::Ice::Double __ice_semiMajor) :
    center(__ice_center),
    angle(__ice_angle),
    semiMinor(__ice_semiMinor),
    semiMajor(__ice_semiMajor)
{
}

::Ice::ObjectPtr
Hesperia::MLP::EllipticalArea::ice_clone() const
{
    ::Hesperia::MLP::EllipticalAreaPtr __p = new ::Hesperia::MLP::EllipticalArea(*this);
    return __p;
}

static const ::std::string __Hesperia__MLP__EllipticalArea_ids[5] =
{
    "::Hesperia::MLP::EllipticalArea",
    "::Hesperia::MLP::PolygonBase",
    "::Hesperia::MLP::Shape",
    "::Ice::Object",
    "::P::T"
};

bool
Hesperia::MLP::EllipticalArea::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Hesperia__MLP__EllipticalArea_ids, __Hesperia__MLP__EllipticalArea_ids + 5, _s);
}

::std::vector< ::std::string>
Hesperia::MLP::EllipticalArea::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Hesperia__MLP__EllipticalArea_ids[0], &__Hesperia__MLP__EllipticalArea_ids[5]);
}

const ::std::string&
Hesperia::MLP::EllipticalArea::ice_id(const ::Ice::Current&) const
{
    return __Hesperia__MLP__EllipticalArea_ids[0];
}

const ::std::string&
Hesperia::MLP::EllipticalArea::ice_staticId()
{
    return __Hesperia__MLP__EllipticalArea_ids[0];
}

void
Hesperia::MLP::EllipticalArea::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    center.__write(__os);
    __os->write(angle);
    __os->write(semiMinor);
    __os->write(semiMajor);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    PolygonBase::__write(__os);
#else
    ::Hesperia::MLP::PolygonBase::__write(__os);
#endif
}

void
Hesperia::MLP::EllipticalArea::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    center.__read(__is);
    __is->read(angle);
    __is->read(semiMinor);
    __is->read(semiMajor);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    PolygonBase::__read(__is, true);
#else
    ::Hesperia::MLP::PolygonBase::__read(__is, true);
#endif
}

void
Hesperia::MLP::EllipticalArea::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::EllipticalArea was not generated with stream support";
    throw ex;
}

void
Hesperia::MLP::EllipticalArea::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::EllipticalArea was not generated with stream support";
    throw ex;
}

class __F__Hesperia__MLP__EllipticalArea : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::Hesperia::MLP::EllipticalArea::ice_staticId());
        return new ::Hesperia::MLP::EllipticalArea;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__Hesperia__MLP__EllipticalArea_Ptr = new __F__Hesperia__MLP__EllipticalArea;

const ::Ice::ObjectFactoryPtr&
Hesperia::MLP::EllipticalArea::ice_factory()
{
    return __F__Hesperia__MLP__EllipticalArea_Ptr;
}

class __F__Hesperia__MLP__EllipticalArea__Init
{
public:

    __F__Hesperia__MLP__EllipticalArea__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::Hesperia::MLP::EllipticalArea::ice_staticId(), ::Hesperia::MLP::EllipticalArea::ice_factory());
    }

    ~__F__Hesperia__MLP__EllipticalArea__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::Hesperia::MLP::EllipticalArea::ice_staticId());
    }
};

static __F__Hesperia__MLP__EllipticalArea__Init __F__Hesperia__MLP__EllipticalArea__i;

#ifdef __APPLE__
extern "C" { void __F__Hesperia__MLP__EllipticalArea__initializer() {} }
#endif

void 
Hesperia::MLP::__patch__EllipticalAreaPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Hesperia::MLP::EllipticalAreaPtr* p = static_cast< ::Hesperia::MLP::EllipticalAreaPtr*>(__addr);
    assert(p);
    *p = ::Hesperia::MLP::EllipticalAreaPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Hesperia::MLP::EllipticalArea::ice_staticId(), v->ice_id());
    }
}

bool
Hesperia::MLP::operator==(const ::Hesperia::MLP::EllipticalArea& l, const ::Hesperia::MLP::EllipticalArea& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Hesperia::MLP::operator<(const ::Hesperia::MLP::EllipticalArea& l, const ::Hesperia::MLP::EllipticalArea& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

Hesperia::MLP::MultiLineString::MultiLineString(const ::Hesperia::MLP::LineStringSeq& __ice_lines) :
    lines(__ice_lines)
{
}

::Ice::ObjectPtr
Hesperia::MLP::MultiLineString::ice_clone() const
{
    ::Hesperia::MLP::MultiLineStringPtr __p = new ::Hesperia::MLP::MultiLineString(*this);
    return __p;
}

static const ::std::string __Hesperia__MLP__MultiLineString_ids[4] =
{
    "::Hesperia::MLP::MultiLineString",
    "::Hesperia::MLP::Shape",
    "::Ice::Object",
    "::P::T"
};

bool
Hesperia::MLP::MultiLineString::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Hesperia__MLP__MultiLineString_ids, __Hesperia__MLP__MultiLineString_ids + 4, _s);
}

::std::vector< ::std::string>
Hesperia::MLP::MultiLineString::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Hesperia__MLP__MultiLineString_ids[0], &__Hesperia__MLP__MultiLineString_ids[4]);
}

const ::std::string&
Hesperia::MLP::MultiLineString::ice_id(const ::Ice::Current&) const
{
    return __Hesperia__MLP__MultiLineString_ids[0];
}

const ::std::string&
Hesperia::MLP::MultiLineString::ice_staticId()
{
    return __Hesperia__MLP__MultiLineString_ids[0];
}

void
Hesperia::MLP::MultiLineString::__incRef()
{
    __gcIncRef();
}

void
Hesperia::MLP::MultiLineString::__decRef()
{
    __gcDecRef();
}

void
Hesperia::MLP::MultiLineString::__addObject(::IceInternal::GCCountMap& _c)
{
    ::IceInternal::GCCountMap::iterator pos = _c.find(this);
    if(pos == _c.end())
    {
        _c[this] = 1;
    }
    else
    {
        ++pos->second;
    }
}

bool
Hesperia::MLP::MultiLineString::__usesClasses()
{
    return true;
}

void
Hesperia::MLP::MultiLineString::__gcReachable(::IceInternal::GCCountMap& _c) const
{
    {
        for(::Hesperia::MLP::LineStringSeq::const_iterator _i0 = lines.begin(); _i0 != lines.end(); ++_i0)
        {
            if((*_i0))
            {
                ::IceInternal::upCast((*_i0).get())->__addObject(_c);
            }
        }
    }
}

void
Hesperia::MLP::MultiLineString::__gcClear()
{
    {
        for(::Hesperia::MLP::LineStringSeq::iterator _i0 = lines.begin(); _i0 != lines.end(); ++_i0)
        {
            if((*_i0))
            {
                if(::IceInternal::upCast((*_i0).get())->__usesClasses())
                {
                    ::IceInternal::upCast((*_i0).get())->__decRefUnsafe();
                    (*_i0).__clearHandleUnsafe();
                }
                else
                {
                    (*_i0) = 0;
                }
            }
        }
    }
}

void
Hesperia::MLP::MultiLineString::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    if(lines.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::Hesperia::MLP::__writeLineStringSeq(__os, &lines[0], &lines[0] + lines.size());
    }
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Shape::__write(__os);
#else
    ::Hesperia::MLP::Shape::__write(__os);
#endif
}

void
Hesperia::MLP::MultiLineString::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    ::Hesperia::MLP::__readLineStringSeq(__is, lines);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Shape::__read(__is, true);
#else
    ::Hesperia::MLP::Shape::__read(__is, true);
#endif
}

void
Hesperia::MLP::MultiLineString::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::MultiLineString was not generated with stream support";
    throw ex;
}

void
Hesperia::MLP::MultiLineString::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::MultiLineString was not generated with stream support";
    throw ex;
}

class __F__Hesperia__MLP__MultiLineString : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::Hesperia::MLP::MultiLineString::ice_staticId());
        return new ::Hesperia::MLP::MultiLineString;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__Hesperia__MLP__MultiLineString_Ptr = new __F__Hesperia__MLP__MultiLineString;

const ::Ice::ObjectFactoryPtr&
Hesperia::MLP::MultiLineString::ice_factory()
{
    return __F__Hesperia__MLP__MultiLineString_Ptr;
}

class __F__Hesperia__MLP__MultiLineString__Init
{
public:

    __F__Hesperia__MLP__MultiLineString__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::Hesperia::MLP::MultiLineString::ice_staticId(), ::Hesperia::MLP::MultiLineString::ice_factory());
    }

    ~__F__Hesperia__MLP__MultiLineString__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::Hesperia::MLP::MultiLineString::ice_staticId());
    }
};

static __F__Hesperia__MLP__MultiLineString__Init __F__Hesperia__MLP__MultiLineString__i;

#ifdef __APPLE__
extern "C" { void __F__Hesperia__MLP__MultiLineString__initializer() {} }
#endif

void 
Hesperia::MLP::__patch__MultiLineStringPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Hesperia::MLP::MultiLineStringPtr* p = static_cast< ::Hesperia::MLP::MultiLineStringPtr*>(__addr);
    assert(p);
    *p = ::Hesperia::MLP::MultiLineStringPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Hesperia::MLP::MultiLineString::ice_staticId(), v->ice_id());
    }
}

bool
Hesperia::MLP::operator==(const ::Hesperia::MLP::MultiLineString& l, const ::Hesperia::MLP::MultiLineString& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Hesperia::MLP::operator<(const ::Hesperia::MLP::MultiLineString& l, const ::Hesperia::MLP::MultiLineString& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

Hesperia::MLP::MultiPoint::MultiPoint(const ::Hesperia::MLP::PointSeq& __ice_points) :
    points(__ice_points)
{
}

::Ice::ObjectPtr
Hesperia::MLP::MultiPoint::ice_clone() const
{
    ::Hesperia::MLP::MultiPointPtr __p = new ::Hesperia::MLP::MultiPoint(*this);
    return __p;
}

static const ::std::string __Hesperia__MLP__MultiPoint_ids[4] =
{
    "::Hesperia::MLP::MultiPoint",
    "::Hesperia::MLP::Shape",
    "::Ice::Object",
    "::P::T"
};

bool
Hesperia::MLP::MultiPoint::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Hesperia__MLP__MultiPoint_ids, __Hesperia__MLP__MultiPoint_ids + 4, _s);
}

::std::vector< ::std::string>
Hesperia::MLP::MultiPoint::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Hesperia__MLP__MultiPoint_ids[0], &__Hesperia__MLP__MultiPoint_ids[4]);
}

const ::std::string&
Hesperia::MLP::MultiPoint::ice_id(const ::Ice::Current&) const
{
    return __Hesperia__MLP__MultiPoint_ids[0];
}

const ::std::string&
Hesperia::MLP::MultiPoint::ice_staticId()
{
    return __Hesperia__MLP__MultiPoint_ids[0];
}

void
Hesperia::MLP::MultiPoint::__incRef()
{
    __gcIncRef();
}

void
Hesperia::MLP::MultiPoint::__decRef()
{
    __gcDecRef();
}

void
Hesperia::MLP::MultiPoint::__addObject(::IceInternal::GCCountMap& _c)
{
    ::IceInternal::GCCountMap::iterator pos = _c.find(this);
    if(pos == _c.end())
    {
        _c[this] = 1;
    }
    else
    {
        ++pos->second;
    }
}

bool
Hesperia::MLP::MultiPoint::__usesClasses()
{
    return true;
}

void
Hesperia::MLP::MultiPoint::__gcReachable(::IceInternal::GCCountMap& _c) const
{
    {
        for(::Hesperia::MLP::PointSeq::const_iterator _i0 = points.begin(); _i0 != points.end(); ++_i0)
        {
            if((*_i0))
            {
                ::IceInternal::upCast((*_i0).get())->__addObject(_c);
            }
        }
    }
}

void
Hesperia::MLP::MultiPoint::__gcClear()
{
    {
        for(::Hesperia::MLP::PointSeq::iterator _i0 = points.begin(); _i0 != points.end(); ++_i0)
        {
            if((*_i0))
            {
                if(::IceInternal::upCast((*_i0).get())->__usesClasses())
                {
                    ::IceInternal::upCast((*_i0).get())->__decRefUnsafe();
                    (*_i0).__clearHandleUnsafe();
                }
                else
                {
                    (*_i0) = 0;
                }
            }
        }
    }
}

void
Hesperia::MLP::MultiPoint::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    if(points.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::Hesperia::MLP::__writePointSeq(__os, &points[0], &points[0] + points.size());
    }
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Shape::__write(__os);
#else
    ::Hesperia::MLP::Shape::__write(__os);
#endif
}

void
Hesperia::MLP::MultiPoint::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    ::Hesperia::MLP::__readPointSeq(__is, points);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Shape::__read(__is, true);
#else
    ::Hesperia::MLP::Shape::__read(__is, true);
#endif
}

void
Hesperia::MLP::MultiPoint::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::MultiPoint was not generated with stream support";
    throw ex;
}

void
Hesperia::MLP::MultiPoint::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::MultiPoint was not generated with stream support";
    throw ex;
}

class __F__Hesperia__MLP__MultiPoint : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::Hesperia::MLP::MultiPoint::ice_staticId());
        return new ::Hesperia::MLP::MultiPoint;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__Hesperia__MLP__MultiPoint_Ptr = new __F__Hesperia__MLP__MultiPoint;

const ::Ice::ObjectFactoryPtr&
Hesperia::MLP::MultiPoint::ice_factory()
{
    return __F__Hesperia__MLP__MultiPoint_Ptr;
}

class __F__Hesperia__MLP__MultiPoint__Init
{
public:

    __F__Hesperia__MLP__MultiPoint__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::Hesperia::MLP::MultiPoint::ice_staticId(), ::Hesperia::MLP::MultiPoint::ice_factory());
    }

    ~__F__Hesperia__MLP__MultiPoint__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::Hesperia::MLP::MultiPoint::ice_staticId());
    }
};

static __F__Hesperia__MLP__MultiPoint__Init __F__Hesperia__MLP__MultiPoint__i;

#ifdef __APPLE__
extern "C" { void __F__Hesperia__MLP__MultiPoint__initializer() {} }
#endif

void 
Hesperia::MLP::__patch__MultiPointPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Hesperia::MLP::MultiPointPtr* p = static_cast< ::Hesperia::MLP::MultiPointPtr*>(__addr);
    assert(p);
    *p = ::Hesperia::MLP::MultiPointPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Hesperia::MLP::MultiPoint::ice_staticId(), v->ice_id());
    }
}

bool
Hesperia::MLP::operator==(const ::Hesperia::MLP::MultiPoint& l, const ::Hesperia::MLP::MultiPoint& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Hesperia::MLP::operator<(const ::Hesperia::MLP::MultiPoint& l, const ::Hesperia::MLP::MultiPoint& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

Hesperia::MLP::MultiPolygon::MultiPolygon(const ::Hesperia::MLP::PolygonBaseSeq& __ice_polygons) :
    polygons(__ice_polygons)
{
}

::Ice::ObjectPtr
Hesperia::MLP::MultiPolygon::ice_clone() const
{
    ::Hesperia::MLP::MultiPolygonPtr __p = new ::Hesperia::MLP::MultiPolygon(*this);
    return __p;
}

static const ::std::string __Hesperia__MLP__MultiPolygon_ids[4] =
{
    "::Hesperia::MLP::MultiPolygon",
    "::Hesperia::MLP::Shape",
    "::Ice::Object",
    "::P::T"
};

bool
Hesperia::MLP::MultiPolygon::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Hesperia__MLP__MultiPolygon_ids, __Hesperia__MLP__MultiPolygon_ids + 4, _s);
}

::std::vector< ::std::string>
Hesperia::MLP::MultiPolygon::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Hesperia__MLP__MultiPolygon_ids[0], &__Hesperia__MLP__MultiPolygon_ids[4]);
}

const ::std::string&
Hesperia::MLP::MultiPolygon::ice_id(const ::Ice::Current&) const
{
    return __Hesperia__MLP__MultiPolygon_ids[0];
}

const ::std::string&
Hesperia::MLP::MultiPolygon::ice_staticId()
{
    return __Hesperia__MLP__MultiPolygon_ids[0];
}

void
Hesperia::MLP::MultiPolygon::__incRef()
{
    __gcIncRef();
}

void
Hesperia::MLP::MultiPolygon::__decRef()
{
    __gcDecRef();
}

void
Hesperia::MLP::MultiPolygon::__addObject(::IceInternal::GCCountMap& _c)
{
    ::IceInternal::GCCountMap::iterator pos = _c.find(this);
    if(pos == _c.end())
    {
        _c[this] = 1;
    }
    else
    {
        ++pos->second;
    }
}

bool
Hesperia::MLP::MultiPolygon::__usesClasses()
{
    return true;
}

void
Hesperia::MLP::MultiPolygon::__gcReachable(::IceInternal::GCCountMap& _c) const
{
    {
        for(::Hesperia::MLP::PolygonBaseSeq::const_iterator _i0 = polygons.begin(); _i0 != polygons.end(); ++_i0)
        {
            if((*_i0))
            {
                ::IceInternal::upCast((*_i0).get())->__addObject(_c);
            }
        }
    }
}

void
Hesperia::MLP::MultiPolygon::__gcClear()
{
    {
        for(::Hesperia::MLP::PolygonBaseSeq::iterator _i0 = polygons.begin(); _i0 != polygons.end(); ++_i0)
        {
            if((*_i0))
            {
                if(::IceInternal::upCast((*_i0).get())->__usesClasses())
                {
                    ::IceInternal::upCast((*_i0).get())->__decRefUnsafe();
                    (*_i0).__clearHandleUnsafe();
                }
                else
                {
                    (*_i0) = 0;
                }
            }
        }
    }
}

void
Hesperia::MLP::MultiPolygon::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    if(polygons.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::Hesperia::MLP::__writePolygonBaseSeq(__os, &polygons[0], &polygons[0] + polygons.size());
    }
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Shape::__write(__os);
#else
    ::Hesperia::MLP::Shape::__write(__os);
#endif
}

void
Hesperia::MLP::MultiPolygon::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    ::Hesperia::MLP::__readPolygonBaseSeq(__is, polygons);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Shape::__read(__is, true);
#else
    ::Hesperia::MLP::Shape::__read(__is, true);
#endif
}

void
Hesperia::MLP::MultiPolygon::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::MultiPolygon was not generated with stream support";
    throw ex;
}

void
Hesperia::MLP::MultiPolygon::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::MultiPolygon was not generated with stream support";
    throw ex;
}

class __F__Hesperia__MLP__MultiPolygon : public ::Ice::ObjectFactory
{
public:

    virtual ::Ice::ObjectPtr
    create(const ::std::string& type)
    {
        assert(type == ::Hesperia::MLP::MultiPolygon::ice_staticId());
        return new ::Hesperia::MLP::MultiPolygon;
    }

    virtual void
    destroy()
    {
    }
};

static ::Ice::ObjectFactoryPtr __F__Hesperia__MLP__MultiPolygon_Ptr = new __F__Hesperia__MLP__MultiPolygon;

const ::Ice::ObjectFactoryPtr&
Hesperia::MLP::MultiPolygon::ice_factory()
{
    return __F__Hesperia__MLP__MultiPolygon_Ptr;
}

class __F__Hesperia__MLP__MultiPolygon__Init
{
public:

    __F__Hesperia__MLP__MultiPolygon__Init()
    {
        ::IceInternal::factoryTable->addObjectFactory(::Hesperia::MLP::MultiPolygon::ice_staticId(), ::Hesperia::MLP::MultiPolygon::ice_factory());
    }

    ~__F__Hesperia__MLP__MultiPolygon__Init()
    {
        ::IceInternal::factoryTable->removeObjectFactory(::Hesperia::MLP::MultiPolygon::ice_staticId());
    }
};

static __F__Hesperia__MLP__MultiPolygon__Init __F__Hesperia__MLP__MultiPolygon__i;

#ifdef __APPLE__
extern "C" { void __F__Hesperia__MLP__MultiPolygon__initializer() {} }
#endif

void 
Hesperia::MLP::__patch__MultiPolygonPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Hesperia::MLP::MultiPolygonPtr* p = static_cast< ::Hesperia::MLP::MultiPolygonPtr*>(__addr);
    assert(p);
    *p = ::Hesperia::MLP::MultiPolygonPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Hesperia::MLP::MultiPolygon::ice_staticId(), v->ice_id());
    }
}

bool
Hesperia::MLP::operator==(const ::Hesperia::MLP::MultiPolygon& l, const ::Hesperia::MLP::MultiPolygon& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Hesperia::MLP::operator<(const ::Hesperia::MLP::MultiPolygon& l, const ::Hesperia::MLP::MultiPolygon& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}
